# include <config.h>
# include <stdio.h>
# include <setjmp.h>
# include <ctype.h>
# include <math.h>

# define __LIST__

# ifndef  __PARAM_HEADER__
# include <sys/param.h>         /***    Def. der Zeitaufloesung  HZ    ***/
# endif

# ifndef  _TYPES_
# include <sys/types.h>         /***    Def. d. Typs time_t und der    ***/
# endif                         /***    Datentypen in  struct  stat    ***/

# include <sys/times.h>         /***    Definition der Struktur tms    ***/

# ifndef __STAT_HEADER__
# include <sys/stat.h>          /***    Definition von  struct stat    ***/
# endif

# ifndef _NFILE
# define _NFILE NOFILE
# endif


# define           BASIS  (1<<30)
# define              _0  (1<<30)
# define           ERROR  (-(1<<30))
# define            atom  int
# define          single  int
# define            list  int
# define             obj  int      

#ifdef ___HP
# define                ltop(L) ((PCELL)(L)) 
# define                ptol(p) ((int) (p)) 
#else  
#ifdef ___MX2
# define                ltop(L) ((PCELL)(L))
# define                ptol(p) ((int) (p))
#else
# define                ltop(L) ((PCELL)((L)&~(1<<30)))
# define                ptol(p) ((int)(p) | BASIS)
#endif
#endif

# define           fgetc  xfgetc
# define           fgets  xfgets
# define         fprintf  xfprintf
# define           fputc  xfputc
# define     fputo(a,pf)  (isatom(a)?fputa(a,pf):fputl(a,pf))
# define           fputs  xfputs
# define          geta()  fgeta(stdin)
# undef getc
# define            getc  xfgetc
# undef getchar
# define       getchar()  xfgetc(stdin)
# define         getcb()  fgetcb(stdin)
# define         getcs()  fgetcs(stdin)
# define            gets  xgets
# define          getl()  fgetl(stdin)
# define          geto()  fgeto(stdin)
# define        lines(k)  flines(k,stdout)
# define          printf  xprintf
# define         puta(a)  fputa(a,stdout)
# define      putbits(a)  fputbits(a,stdout)
# undef  putc
# define      putc(c,pf)  xfputc(c,pf)
# undef  putchar
# define      putchar(c)  xfputc(c,stdout)
# define         putl(L)  fputl(L,stdout)
# define   putlstruct(L)  fputlstruct(L,stdout)
# define         puto(a)  (isatom(a)?fputa(a,stdout):fputl(a,stdout))
# define         puts(s)  xfputs(s,stdout)
# define    sputa(a,str)  ( sprintf(str,"%d",a), str )
# define          tab(n)  ftab(n,stdout)


# define               isatom(a)  ( (a) > -BASIS && (a) < BASIS )
# define             issingle(a)  isatom(a)
# define                isobj(a)  ( isatom(a) || islist(a) )
# define           lcomp2(a,b,L)  lcomp(a,lcomp(b,L))                     
                              /*a*/
# define         lcomp3(a,b,c,L)  lcomp(a,lcomp(b,lcomp(c,L)))            
                              /*a,b*/
# define       lcomp4(a,b,c,d,L)  lcomp(a,lcomp(b,lcomp(c,lcomp(d,L))))   
                              /*a,b,c*/
# define     lcomp5(a,b,c,d,e,L)  lcomp(a,lcomp(b,lcomp(c,lcomp(d,lcomp(e,\
L)))))
			     /*a-d*/
# define   lcomp6(a,b,c,d,e,f,L)  lcomp(a,lcomp(b,lcomp(c,lcomp(d,lcomp(e,\
lcomp(f,L))))))
			     /*a-e*/
# define  lfirst(L)  ((ltop(L))->inh)
# define  lred(L)  ((ltop(L))->adr)

# define  lsecond(L)  (lfirst( lred(L) ) )
# define  lthird(L)   (lfirst( lred( lred(L) ) ) )
# define  lfourth(L)  (lfirst( lred( lred ( lred(L) ) ) ) )
# define  lfifth(L)   (lfirst( lred( lred( lred ( lred(L)  ) ) ) ) )

# define                list1(a)  lcomp(a,_0)
# define              list2(a,b)  lcomp(a,lcomp(b,_0))                    
                             /*a*/
# define            list3(a,b,c)  lcomp(a,lcomp(b,lcomp(c,_0)))           
                             /*a,b*/
# define          list4(a,b,c,d)  lcomp(a,lcomp(b,lcomp(c,lcomp(d,_0))))  
                             /*a,b,c*/
# define        list5(a,b,c,d,e)  lcomp(a,lcomp(b,lcomp(c,lcomp(d,lcomp(e,\
_0)))))
			     /*a-d*/
# define      list6(a,b,c,d,e,f)  lcomp(a,lcomp(b,lcomp(c,lcomp(d,lcomp(e,\
lcomp(f,_0))))))
			     /*a-e*/
# define  lred2(L)  (lred( lred( L ) ))
# define  lred3(L)  (lred( lred( lred( L ) ) ))
# define  lred4(L)  (lred( lred( lred( lred ( L ) ) ) ) )
# define  lred5(L)  (lred( lred( lred( lred (lred (L) ) ) ) ) )           

typedef struct {
	int adr;
	int inh;
} CELL, *PCELL;  



#ifdef ___DOCH_NICHT___
int *___LTOP_HP; 
# define  lsfirst(L,a)  ( ___LTOP_HP = &L, ((PCELL)(L))->inh = (a))
# define  lsred(L,a)  ( ___LTOP_HP = &L, ((PCELL)(L))->adr = (a))
#else 
# define  lsfirst(L,a)  ( ((ltop(L))->inh)=(a) )
			     /*L oder a keine Fkt*/
# define  lsred(L,L1)  ( ((ltop(L))->adr)=(L1) )
			     /*L oder L1 keine Fkt*/
#endif





# define            lsuffix(L,a)  lconc(L,lcomp(a,_0))
			     /*L*/
# define            usunion(L,M)  lconc(usdiff(L,M),M)
			     /*M*/

# define 	lsize(l)  lsizerec (l,1)




extern PCELL   SPACE;
extern PCELL   *BL_START;
extern int     SP_MAX, ST_SIZE /*, STOCK_SZ */;
extern int     BL_SIZE, BL_NR, BL_NR_MAX;
extern int     GC_CC, GC_COUNT, GC_MESS, GC_QUOTE, GC_TEST, GC_TIME;
extern int     ST_INDEX, **STACK /*, *STOCK */;
extern list    AVAIL;
extern single  LN_SIZE, MARGIN;
/* extern int  STOCK_IND; */
extern obj     DUM, NUM;
/* extern int  TRACE_ON, TRACE_CC; */
extern jmp_buf FL_JMP;
