/*C     Wegen srctrans steht an dieser Stelle MACRO !

	Hauptprogramm des Simath - Calculators * simcalc *

	Ein Eingabestring wird vom Bildschirm eingelesen.
	Das Programm entscheidet, ob und an welche Unterprogramme der
	Eingabestring weitergegeben wird.
	Dabei koennen folgende Faelle eintreten:
	1.) Falls das erste eingelesene Zeichen ein '%' ist,
	    so koennen folgende Faelle eintreten:
	    a. %?
	       Die letzten zehn Rechenanweisungen werden auf Bildschirm
	       geschrieben.
	    b. %n
	       Die Rechenanweisung mit der Kennziffer n wird auf Bild-
	       schirm geschrieben und kann ueberarbeitet werden.
	    c. %
	       Die letzte Rechenanweisung wird auf Bildschirm geschrie-
	       ben und kann ueberarbeitet werden.
	2.) Falls die Eingabe nur aus einem carriage return besteht, so
	    wird nichts ausgefuehrt.
	3.) Falls das erste eingelesene Zeichen das END-Zeichen ist,
	    so bricht das Programm ab.
	4.) Falls das erste eingelesene Zeichen ein '$' ist, so wird
	    der dem '$' folgende Shell-Befehl ausgefuehrt.
	5.) Falls das erste eingelesene Zeichen ein '!' ist, so wird
	    eine simulierte Shell-Ebene geschaffen.
	6.) Falls das erste eingelesene Zeichen ein '?' ist, so wird
	    der Eingabestring an das Unterprogramm inform weitergegeben.
	7.) Falls das erste eingelesene Zeichen ein '&' ist, so wird
	    die Datei calc.kopfmx bzw. calc.kopfas aufgelistet.
	8.) Falls das erste eingelesene Zeichen das DELETE-Zeichen ist,
	    so wird der aktuelle Programmzustand gerettet und das Pro-
	    gramm geht zu der von dem Systemaufruf setjmp markierten
	    Stelle.
	9.) Bei Eingabe von vardel wird die Funktion osloesche aufge-
	    rufen, die dem Benutzer anbietet Variablen zu loeschen.
       10.) Bei Eingabe von logon... wird der Eingabestring  an das
	    Unterprogramm logon weitergegeben zur Eroeffnung einer
	    Protokolldatei.
	    Bei Eingabe von logoff wird die aktuelle Protokolldatei
	    geschlossen und bei Eingabe von loglist wird die aktuelle
	    Protokolldatei, falls eine solche geoeffnet ist, auf
	    Bildschirm aufgelistet.
       11.) Bei Eingabe von staton wird der Statistikschalter eingeschaltet
	    und bei Eingabe von statoff wird dieser wieder auf 0 gesetzt.
       12.) Bei Eingabe von owoff  wird der Ueberschreibeschutz ausgeschaltet
	    und bei Eingabe von owon wird dieser wieder auf 1 gesetzt.
       13.) Bei Eingabe von fopen, fclose und fread wird eine Einlesedatei
	    geoeffnet, geschlossen oder aus ihr gelesen. Mit openf sieht
	    man, welche Dateien zum Lesen geoeffnet sind.
       14.) Alle uebrigen Eingabestrings werden zuerst an das Unter-
	    programm error weitergegeben, wo der Eingabestring auf
	    syntaktische Korrektheit untersucht wird.
	    Ist dies der Fall, so wird der Eingabestring an das Unter-
	    programm rechnung weitergegeben, wo er ausgewertet wird.
	    Stehen in einem Eingabestring mehrere durch '_',';' ge-
	    trennte Befehle, so wird der Eingabestring sukzessive ab-
	    gearbeitet. Mehrere Eingabestrings sind nur moeglich bei
	    arithmetischen Ausdruecken.
	LEN ist die Laenge des auszuwerteten Strings, die an basad
	uebergebe wird.
	Der include-file <_calc.h> wird benoetigt.
C*/
/*H
	Version  1      02.06.1987      H.Stroeher/M.Mang
	Version  2      10.01.1990      U.Schneiders ( MX- AS- Version )
	Version  2.1    17.09.1990      U.Schneiders ( ow, fread etc. )
	Version  3      23.12.1991      U.Schneiders ( SM_HOME )
	Version  3.1    07.01.1993      U.Schneiders (scr_page fuer MX)
H*/
/*cS
	Aufgerufen werden: calc_fclose, calc_fopen, calc_fread, error,
			   fclose, fflush, fileaus, free, gets,
			   interrupt, lines, malloc, rechnung, setocnt,
			   settime, statistic, strcat, strcat2, 
			   strcpy, strncmp, structin, system, ungetc
		   Macros: fprintf, getc, printf
	    Systemaufrufe: longjmp, setjmp, signal
Sc*/

# include <config.h>

/***# ifdef ___MX_RL
# include <sgtty.h>
struct sgttyb cbrbild, ncbrbild;
struct sgttyb *pcbr = &cbrbild, *pncbr = &ncbrbild;**/

# ifdef ___MX
# include <sgtty.h>
struct sgttyb cbrbild, ncbrbild;
struct sgttyb *pcbr = &cbrbild, *pncbr = &ncbrbild;
# endif
# ifndef ___MX_RL
# include<curses.h>
#endif             

# include <_calc.h>

struct var varlist[VARLISTLENGTH];

FILE *datei, *fpt[10], *fopen();
char *comm,*dhelp, *datn, *fname[10];
single ps, hps, as, cellc, cellabs, tdiff, tabs, statsch, owsch, fz, DIGITS, MX;
single ecqnfsch, ecsch, modsch, ssch, pzsch, nfsch, gfsch, gfchar;
single fosch, schleife, breaksch;
list VNF, VGF;

static char *string, *bz[10];
jmp_buf res;
extern single sch1;

void interrupt()
{
	char *h;
	single i;

	if ( sch1) {
# ifndef ___SIMCALC_RL
	/**	h = bz[9];**/
		for (i = 9; i > 0; i--) strcpy(bz[i],bz[i-1]);
		strcpy(bz[0],string);
		/**string = h;**/
# endif
		printf("\n ********    Result is computed.     ********\n");
		printf(" ********   Output is interrupted.   ********\n\n");
		if ( ps) {
		       fprintf(datei, "\nout: ********    Result is computed.     ********\n");
		       fprintf(datei, "out: ********   Output is interrupted.   ********\n\n");
		}
	}
	else {
		i=0;
# ifdef ___MX_RL
		while(i/78 <= strlen( string )/78 ) {i += 78; putc('\n', stdout);}
# else
		while(i/(*stdscr)._maxx <= strlen( string )/(*stdscr)._maxx ) {i += (*stdscr)._maxx; putc('\n', stdout);}
#endif
		printf("\n ********     Calculation is interrupted.     *********\n\n");
		if ( ps) fprintf(datei,"\nout: ********     Calculation is interrupted.     ********\n\n");
	}
	*string = '\0';
	tdiff = settime(); tabs+=tdiff;
	if ( statsch ) statistic( tdiff );

	for( i = NUM_FUNC; i < VARLISTLENGTH; i++ )        
	{  	if(*varlist[i].varname == '\0' ) break;     
        	if( varlist[i].varwert == -BASIS ) 
	        {      varlist[i].varwert = 0;
  	               *varlist[i].varname = '\0';
		}
	} 

# ifdef ___MX_RL
	setocnt( stdout, MARGIN);
	putc(27,stdout); putc('[',stdout); putc('7',stdout); putc('p',stdout);
# else
	refresh();
# endif
	longjmp(res,0);
}


main()
{
	/*** Deklarationen und Vorbesetzungen ***/

	single stz, LEN = 0;
	single i, y, pi, psch;
	single vorb = 0;
	char s, *strcat(), *hil, *getgnu(),*getenv();
	char *h;
# ifndef ___MX_RL
	char *str;
# endif
	single m, n, sch = 1;

if( llength( _0 ) )
{
	setspace();
	setstack();
	qnfielpifacts();
}
	setstacksp(1000);

	init( VNF, VGF );
	MX = VARLISTLENGTH;
	string = malloc( MAXL ); h = malloc( MAXL );
	hil = malloc(10); comm = malloc(10); dhelp = malloc(25);
# ifndef ___MX_RL
	str = malloc(MAXL);
	*str = '\0';
# endif
	*string = '\0'; *h = '\0';
	*hil = '\0'; *comm = '\0'; *dhelp = '\0';

# ifdef ___SIMCALC_RL
	comm = getenv("PAGER");
	if(comm == NULL) comm = "more";
# else 
	comm = "more";
# endif

	i=getpid();
	sprintf(hil,"%d",i);
	strcat2(dhelp, "/tmp/___H.sIm",hil);

	for (i = 9; i >= 0; i--)
	{
# ifndef ___SIMCALC_RL
		bz[i] = malloc( MAXL );
		*bz[i] = '\0';
# endif
		fname[i] = malloc( 15 );
		*fname[i] = '\0';
	}
	datn = malloc( 20 );
	fz = 0;

# ifndef ___MX_RL
	init_simcalc();
	scrollok( stdscr, TRUE );
# endif
# ifndef ___SIMCALC_RL
# ifndef ___MX
	strcat2( h, SM_HOME, "/calcul/calc.kopfas" );
# else
	strcat2( h, SM_HOME, "/calcul/calc.kopfmx" );
# endif
	scr_page( h ); 
# else
	strcat4(h,comm," ",SM_HOME,"/calcul/calc.kopfas");
	system(h);
# endif

	ps = 0; hps = 0; statsch = 0; owsch = 1; DIGITS = 37;
	ecqnfsch = 0; ecsch = 0; modsch = 0; ssch = 0; pzsch = 0; nfsch = 0; gfsch = 0; gfchar = 0; schleife = 0; fosch=0; breaksch=0;
	tdiff=settime(); tabs+=tdiff;
	for ( n=0; n<MX; n++ ) {
		varlist[n].varname = malloc(20);
		*varlist[n].varname = '\0';
	}
	n = MX-1;
	init(varlist[0..n].varwert);
#ifdef ___SGI
	gcreinit( 65535,128 );
#endif
	VNF = _0;
	VGF = _0;
	structin( 1 );
	stz = ST_INDEX;
	MARGIN = 1;
	LN_SIZE = 79;

/* Initialisierung Bildschirm setzen */

/***# ifdef ___MX_RL
	gtty(0,pncbr);
	gtty(0,pcbr);
	pcbr->sg_flags |= CBREAK;
	pcbr->sg_flags &= ~ECHO;
# endif **/
# ifdef ___MX
	gtty(0,pncbr);
	gtty(0,pcbr);
	pcbr->sg_flags |= CBREAK;
	pcbr->sg_flags &= ~ECHO;
# endif 

	/*** Einlesen des Eingabestrings ***/

	while ( sch ) {
		setjmp( res );
		if(schleife)
		{	schleife=0;
			schleiaus();
		}	
		signal( SIGINT, interrupt );
		ST_INDEX = stz;
# ifdef ___MX_RL
		setocnt( stdout, 0);
# ifdef ___MX
		printf("> ");
		setocnt( stdout, 0);
# endif
# else
		refresh();
		addstr("\n > ");
		refresh();
# endif
		if ( ps ) fprintf( datei, "\n" );
# ifdef ___MX
		s = getline(string,1);
# else
# ifndef ___SIMCALC_RL
		getline( string, vorb );
		refresh();
		vorb = 0;
		s = (*string);
# else
		strcpy(string,"> ");
		h = getgnu(string, 0);
		strcpy( string, h );
	
		s = (*string);
# endif
# endif
		switch( s ) {

	/*** alter String ***/

		case '%':
# ifdef ___SIMCALC_RL
			mistake(275);
			break;
# else
			vorb = 1;
			if ( ps ) fprintf(datei,"in : %s\n",string);
			switch (*(string+1)) {
				case '?': vorb = 0;
					printf(" available command lines:\n");
					if ( ps ) fprintf(datei,"out: available command lines:\n");
					for (i = 9; i >= 0; i--) {
						if (*bz[i] != '\0') {
							printf(" <%i>  %s\n",i,bz[i]);
							if ( ps ) fprintf(datei,"out: <%i>  %s\n",i,bz[i]);
							}
						}
					*string = '\0';
					break;
				case '1': strcpy(string,bz[1]); break;
				case '2': strcpy(string,bz[2]); break;
				case '3': strcpy(string,bz[3]); break;
				case '4': strcpy(string,bz[4]); break;
				case '5': strcpy(string,bz[5]); break;
				case '6': strcpy(string,bz[6]); break;
				case '7': strcpy(string,bz[7]); break;
				case '8': strcpy(string,bz[8]); break;
				case '9': strcpy(string,bz[9]); break;
				case '\0':
				case '0': strcpy(string,bz[0]); break;
				default: *string = '\0'; break;
				}
# endif

	/*** Leerer String ***/

		case 10: break;

	/*** Abbruch ***/

		case EOF:
		case 4 : 
# ifndef ___MX_RL
			  endwin();
# endif
			  xprintf("\n\n                                   B Y E\n\n\n");
			  sch = 0;
			  break; 

	/*** Systembefehle ***/

		case '$':if ( ps ) fprintf(datei,"in : %s\n",string); 
# ifndef ___SIMCALC_RL
			/** h = bz[9];**/
			 for (i = 9; i > 0; i--) strcpy( bz[i],bz[i-1]);
			 strcpy(bz[0],string);
# endif
# ifndef ___MX_RL           
			 y = 1; i = 0;
			 while( *(string+y) != '\0' )
			 { 	*(str+i) = *(string+y);
				if( *(string+y) == 'l' && *(string+y+1) == 's' 
                                && ( *(string+y+2) == ' ' || *(string+y+2) == '\0') )
                    	        {	y = y+2;
          				*(str+i+1) = 's';
          				*(str+i+2) = ' ';
          				*(str+i+3) = '-';
          				*(str+i+4) = 'C';
          				*(str+i+5) = ' '; 
					i = i+5;
				}      
				i++; y++;
			 }
			 *(str+i) = '\0';
			 strcat3( h, str, " > " ,dhelp );
			 system( h );  
			 scr_page(dhelp);
			 unlink(dhelp);
# else
			 system( string+1 );
# endif
			 *h = '\0';
	/**		 string = h; **/
			 *string='\0';
			 break;

	/*** Simulierte Shell-Ebene ***/

		case '!': if ( ps ) fprintf(datei,"in : %s\n",string);
			  printf(" >>> branching to a subshell\n");
# ifdef ___MX
			  printf("     Press `END' in order to return to simcalc.\n\n");
			  system("$SHELL");
# else
			  printf("     Type `CTRL/D' or \"exit\" in order to return to simcalc.\n\n");
# ifndef ___SIMCALC_RL
			  sleep( 2 );
			  endwin();
# endif
			  system("$SHELL");
# ifndef ___SIMCALC_RL
			  initscr();
			  scrollok(stdscr, TRUE);
			  cbreak();
			  echo();
# endif
# endif
			  putchar('\n');
			  *string='\0';
			  break;

	/*** '?'-Eingabe ***/

		case 63: if ( ps ) fprintf(datei,"in : ? %s\n",string+1);
			 inform( string+1 );
			 *string = '\0';
			 break;

	/*** '&'-Eingabe ***/

		case '&': pi=1;
			  while(*(string+pi) == ' ') pi++;
			  if(*(string+pi)!='\0')
			  {	
				/*mistake(253);*/
				printf( " ***** Error: Illegal input!\n");
				*string = '\0';
				break;
			  }
# ifndef ___SIMCALC_RL
# ifndef ___MX
			  strcat2( h, SM_HOME, "/calcul/calc.kopfas" );
# else
		          strcat2( h, SM_HOME, "/calcul/calc.kopfmx" );
# endif
			  scr_page( h );
# else
			  /*strcat4(h,comm," ",SM_HOME,"/calcul/calc.kopfas");
			  system(h);*/
			  einzinf( "&" );
# endif
			  if ( ps ) fprintf(datei,"in : & %s\n",string+1); 
			  *string = '\0';
			  break;

		default:

	/*** Beenden des simcalc ***/

			if( !strncmp( string, "quit", 4 ) || !strncmp( string, "exit", 4 ) )
			{
			    string += 4;
			    pi = 0; psch = 1;
			    while( pi < strlen(string) && psch)
			    { if(*(string+pi) != ' ')
			      { mistake(253);
				psch = 0;
			      }
			      pi++;
			    }
			    if(psch) {
# ifndef ___MX_RL
			    	endwin();
# endif
			    	xprintf("\n\n                                   B Y E\n\n\n");
			    	sch = 0;
			    }
			    break;
			}

	/*** Loeschen von Variablen ***/

			 if ( !strncmp( string, "vardel", 6 ) ) {
			 	string += 6;
				pi = 0; psch = 1;
				while( pi < strlen(string) && psch)
				{	if (*(string+pi) != ' ')
					{  mistake(253);
					   psch = 0;
					}
					pi++;
				}
				if( psch )
				{    if ( ps )
				     fprintf( datei, "in : vardel\n");
				     m = osloesche();
				     while ( m == -1 ) m = osloesche();
				}
				*string = '\0';
				break;
			 }

	/*** Einlesen von Datei ***/

			 if ( !strncmp( string, "openf", 5 ) )
			 {      string += 5;
				pi = 0; psch = 1;
				while( pi < strlen(string) && psch )
				{       if ( *(string+pi) != ' ' )
					{ mistake( 253 );
					  psch = 0;
					}
					pi++;
				}
				if( psch )
					fileaus();
				*string = '\0';
				break;
			 }


	/*** Ueberschreibeschutzverwaltung ***/

			 if ( ps ) fprintf(datei,"in : %s\n",string);

			 if ( !strncmp( string, "loglist",7 ) )
			 {      string += 7;
				pi = 0; psch = 1;
				while( pi < strlen(string) && psch )
				{       if ( *(string+pi) != ' ' )
					{ mistake( 253 );
					  psch = 0;
					}
					pi++;
				}
				if( psch )
				{       if ( ps )
					{    char *hilf;
				             hilf = malloc(30);
					     *hilf = '\0';
					     strcat3(hilf,comm," ",datn);
					     fflush( datei );  
# ifdef ___MX_RL
					     system(hilf);
# else
					     scr_page( datn );
# endif
					     free(hilf);
					     break;
					}
					else
					{    printf(" No log file.\n");
					     break;
					}
				}
				*string = '\0';
			 }

	/*** Uebergabe an seqbasad zur Auswertung ***/

# ifdef ___APO_RAM
			LEN = strlen(string)+1;
# endif
			seqbasad(string, interrupt, 0,0, LEN);
# ifndef ___SIMCALC_RL
	/**		h = bz[9]; **/
			for (i = 9; i > 0; i--) strcpy(bz[i],bz[i-1]);
			strcpy(bz[0],string);
	/**		string = h;  **/
# endif
			*string = '\0';
		}
	}
}
